`import Ember from 'ember'`

Sidebar = Ember.ArrayController.extend
    needs: ['application']
    model:
        [
            {route: 'overview', text: 'Overview', items: []}
            {route: 'getstarted', text: 'Getting started', items: []}
            {route: 'component', text: 'Components', items: Ember.A([
                    Ember.Object.create({route: 'component.forms', text: 'Forms', items: []})
                    Ember.Object.create({route: 'component.tabs', text: 'Tabs', items:
                        [
                            {route: 'component.tabs.simple', text: 'Simple'}
                            {route: 'component.tabs.query_params', text: 'Query Params'}
                            {route: 'component.tabs.controller_per_tab', text: 'Controller per Tab'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.wysiwyg', text: 'Wysiwyg Html5', items:
                        [
                            {route: 'component.wysiwyg.simple', text: 'Simple'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.accordion', text: 'Accordion', items:
                        [
                            {route: 'component.accordion.simple', text: 'Simple'}
                            {route: 'component.accordion.query_params', text: 'Query Params'}
                            {route: 'component.accordion.controller_per_item', text: 'Controller per Item'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.tree', text: 'Tree', items:
                        [
                            {route: 'component.tree.simple', text: 'Simple'}
                            {route: 'component.tree.emberdata', text: 'Ember Data'}
                            {route: 'component.tree.async', text: 'Async'}
                            {route: 'component.tree.hoveredactions', text: 'Hovered Actions'}
                            {route: 'component.tree.expand', text: 'Expand'}
                            {route: 'component.tree.multiselection', text: 'Multi Selection'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.list', text: 'List', items:
                        [
                            {route: 'component.list.simple', text: 'Simple'},
                            {route: 'component.list.state', text: 'State'},
                            {route: 'component.list.models', text: 'Models'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.modal', text: 'Modal', items:
                        [
                            {route: 'component.modal.simple', text: 'Simple'},
                            {route: 'component.modal.openifcloseif', text: 'Open If / Close If'},
                            {route: 'component.modal.confirm', text: 'Confirm'},
                            {route: 'component.modal.reuse', text: 'Reuse'},
                            {route: 'component.modal.forms', text: 'Forms'},
                            {route: 'component.modal.emforms', text: 'Ember Forms'}
                        ]
                    }),
                    Ember.Object.create({route: 'component.button', text: 'Button', items: []})
                ])
            }
        ]

    pathChanged: (->
        path = @get('controllers.application.currentPath')
        route = path.substring(0, path.lastIndexOf('.'))
        components =  @get('model').findBy('route', 'component')
        #Close them all first
        components.items.forEach((c) ->
            c.set 'open', false
        )
        #Open the relevant
        route = components.items.findBy('route', route)
        route.set 'open', true if route
    ).observes('controllers.application.currentPath').on('init')

`export default Sidebar`